<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        $sql = <<<'SQL'
            CREATE TABLE production_quantities (
                id					BIGINT GENERATED always AS IDENTITY PRIMARY KEY,

                line_id				BIGINT NOT NULL,
                shift_id			BIGINT NOT NULL,
                plant_id			BIGINT NOT NULL,
                item_id			    BIGINT NOT NULL,

                serial_number		TEXT NOT NULL,

                created_at			TIMESTAMP NOT NULL DEFAULT NOW(),
                updated_at			TIMESTAMP NOT NULL DEFAULT NOW(),
                deleted_at			TIMESTAMP,

                UNIQUE (plant_id, serial_number),
                FOREIGN KEY (item_id) REFERENCES items (id),
                FOREIGN KEY (line_id) REFERENCES lines (id),
                FOREIGN KEY (shift_id) REFERENCES shifts (id),
                FOREIGN KEY (plant_id) REFERENCES plants (id)
            );
        SQL;

        DB::statement($sql);
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('production_quantities');
    }
};
